=== debian/changelog ===
ispc (1.22.0-4) unstable; urgency=medium

  * Fix reproducible build using UTC time stamp.

 -- Francois Mazen <mzf@debian.org>  Tue, 26 Dec 2023 17:32:23 +0100

ispc (1.22.0-3) unstable; urgency=medium

  * Add missing build dependencies for ARM architectures.

 -- Francois Mazen <mzf@debian.org>  Mon, 25 Dec 2023 13:56:32 +0100

ispc (1.22.0-2) unstable; urgency=medium

  * Set supported architecture in d/control

 -- Francois Mazen <mzf@debian.org>  Sat, 18 Nov 2023 09:21:58 +0100

ispc (1.22.0-1) unstable; urgency=medium

  * New Upstream Release
  * Specify architecture for autopkgtests

 -- Francois Mazen <mzf@debian.org>  Fri, 17 Nov 2023 23:10:25 +0100

ispc (1.21.0-1) unstable; urgency=medium

  * Initial Release, based on Yangfl work (closes: #956816)
  * Add autopkgtests for ispc compiler

 -- Francois Mazen <mzf@debian.org>  Thu, 12 Oct 2023 22:25:29 +0200
