=== debian/tests/control ===
Tests: mandelbrot
Architecture: arm64 amd64 armel armhf i386
Depends: ispc, build-essential
Restrictions: allow-stderr
