=== superbuild/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#  Copyright (c) 2023, Intel Corporation
+#  Copyright (c) 2023-2024, Intel Corporation
 #
 # SPDX-License-Identifier: BSD-3-Clause
 
@@ -48,6 +48,7 @@
 set(ISPC_SIGN_KEY "NO" CACHE STRING "Key to sign macOS or Windows build.")
 option(ISPC_INCLUDE_BENCHMARKS "Include ISPC benchmarks (ispc_benchmarks target)" OFF)
 option(ISPC_CROSS "Enable ISPC build with cross compilation support" ON)
+option(ISPC_PACKAGE_EXAMPLES "Package examples into the same archive with ISPC binaries" OFF)
 option(LLVM_DISABLE_ASSERTIONS "Enable LLVM build without assertions" ON)
 option(LLVM_BUILD_OPENMP "Build OpenMP as part of LLVM" OFF)
 option(EXTERNAL_VERBOSE "Enable verbose for external project build and install commands" OFF)
@@ -171,7 +172,7 @@
     set(FULL_STAGE2_LLVM ON)
 
     set(MACOS_VERSION_MIN 10.12)
-    if (NOT MACOS_UNIVERSAL_BIN AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm64")
+    if (NOT MACOS_UNIVERSAL_BIN AND CMAKE_OSX_ARCHITECTURES MATCHES "arm64")
         set(MACOS_VERSION_MIN 11.0)
     endif()
 
@@ -191,9 +192,10 @@
 unset(LLVM_TAG)
 unset(LLVM_VERSION_DOTTED)
 string(REPLACE "." "_" LLVM_VERSION "${LLVM_VERSION}")
-if     (${LLVM_VERSION} STREQUAL 17_0)
-    set(LLVM_TAG    llvmorg-17.0.1)
-    set(LLVM_VERSION_DOTTED 17.0.1)
+if (${LLVM_VERSION} STREQUAL 18_1)
+    set(LLVM_TAG    llvmorg-18.1.2)
+elseif (${LLVM_VERSION} STREQUAL 17_0)
+    set(LLVM_TAG    llvmorg-17.0.6)
 elseif (${LLVM_VERSION} STREQUAL 16_0)
     set(LLVM_TAG    llvmorg-16.0.6)
 elseif (${LLVM_VERSION} STREQUAL 15_0)
@@ -276,5 +278,3 @@
 message(STATUS "PREBUILT_STAGE1_PATH is ${PREBUILT_STAGE1_PATH}")
 message(STATUS "PREBUILT_STAGE2 is ${PREBUILT_STAGE2}")
 message(STATUS "PREBUILT_STAGE2_PATH is ${PREBUILT_STAGE2_PATH}")
-message(STATUS "PREBUILT_XE_STAGE2_PATH is ${PREBUILT_XE_STAGE2_PATH}")
-message(STATUS "EXTERNAL_VERBOSE is ${EXTERNAL_VERBOSE}")
