=== debian/changelog ===
ispc (1.24.0-3) unstable; urgency=medium

  * Improve the patch to fix reproducibility issue with package using
    header generated by ispc.

 -- Francois Mazen <mzf@debian.org>  Thu, 25 Jul 2024 22:40:05 +0200

ispc (1.24.0-2) unstable; urgency=medium

  * Limit architectures for migration to testing (Closes: #1076732)
  * Do not write full file path in generated headers to avoid
    reproductibility issue with other packages.

 -- Francois Mazen <mzf@debian.org>  Tue, 23 Jul 2024 17:34:28 +0200

ispc (1.24.0-1) unstable; urgency=medium

  * New usptream release.
  * Add RT library and autopkgtest.
  * Fix blhc with CMake build output.

 -- Francois Mazen <mzf@debian.org>  Wed, 05 Jun 2024 22:13:47 +0200

ispc (1.23.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove obsolete patch.

 -- Francois Mazen <mzf@debian.org>  Sun, 03 Mar 2024 09:35:40 +0100
