## ispc 1.25.0

=== debian/changelog ===
ispc (1.25.0-1) unstable; urgency=medium

  * New upstream version.
  * Fix llvm version error (Closes: #1084279)
  * Bump standard version to 4.7.0

 -- Francois Mazen <mzf@debian.org>  Wed, 16 Oct 2024 14:12:51 +0200
